diff -ru -X dontdiff linux-2.4.23-pre9/drivers/ide/pci/amd74xx.c linux-2.4.23-pre9-nvpio/drivers/ide/pci/amd74xx.c
--- linux-2.4.23-pre9/drivers/ide/pci/amd74xx.c	2003-06-13 07:51:33.000000000 -0700
+++ linux-2.4.23-pre9-nvpio/drivers/ide/pci/amd74xx.c	2003-11-04 15:39:38.000000000 -0800
@@ -139,7 +139,7 @@
 	pci_read_config_dword(dev, AMD_UDMA_TIMING, &u);
 
 	for (i = 0; i < 4; i++) {
-		setup[i]     = ((t >> ((3 - i) << 1)) & 0x3) + 1;
+		setup[i]     = (t >> ((3 - i) << 1)) & 0x3;
 		recover8b[i] = ((w >> ((1 - (i >> 1)) << 3)) & 0xf) + 1;
 		active8b[i]  = ((w >> (((1 - (i >> 1)) << 3) + 4)) & 0xf) + 1;
 		active[i]    = ((v >> (((3 - i) << 3) + 4)) & 0xf) + 1;
@@ -187,7 +187,7 @@
 	unsigned char t;
 
 	pci_read_config_byte(dev, AMD_ADDRESS_SETUP, &t);
-	t = (t & ~(3 << ((3 - dn) << 1))) | ((FIT(timing->setup, 1, 4) - 1) << ((3 - dn) << 1));
+	t = (t & ~(3 << ((3 - dn) << 1))) | (FIT(timing->setup, 1, 4) << ((3 - dn) << 1));
 	pci_write_config_byte(dev, AMD_ADDRESS_SETUP, t);
 
 	pci_write_config_byte(dev, AMD_8BIT_TIMING + (1 - (dn >> 1)),
